<id>
Hidden User for YaBB 2.1
</id>

<version>
1.7
</version>

<mod info>
Tested on and coded for Yabb 2.1
Loosely based on the "invisibility" mod by Shoeb Omar for Yabb 1 Gold - SP 1.1.  

*********************************************************
Many thanks to JetLi for providing a German translation of this mod!
*********************************************************

**Please read the "readme.txt" file for more extensive information.**

Install notes:
If you have installed other mods that have affected the info center of the board index, or have pushed other tags under the tag list in System.pl, you may have to adjust this mod or install manually.   Please note:  You cannnot have the  Hidden User mod installed and then try to install the Last IP mod (or visa-versa) as portions of both mods modify the same parts of certain files.  Please use the combination Last IP and Hidden User Mod if you wish to use both mods. 

1) Uninstall any previous version of this mod.
2) Run new version of mod.
3) Upload hidden_user.lng to your Languages/English directory.
4) Upload the hidden_user.pl file into your Admin directory (default permisssions will work). 
5) Activate mod in Admin Center (Hidden User Mod link).
6) Check box in "Options" area of user profile to enable hidden user.

Modifies the following files:
-YaBB.pl
-AdminIndex.pl
-Admin/AdminSubList.pl
-Admin/ModList.pl
-Admin/ViewMembers.pl
-Sources/BoardIndex.pl
-Sources/Profile.pl
-Sources/System.pl
-Templates/default/BoardIndex.template
-Adds a new variable in the user's .vars file called "hide_me".  It's either blank or "on".
-Admin Center settings are stored in the Variables directory called "hidden_user.txt".

If you have any problems, comments, or bug reports, send them to: webmaster@eyeontoccoa.com.

Version History:

## 1.0 ##
-- Original Release
## 1.1 ##
-- Added "Most Hidden User" info
-- Consolidated a mod line in Profile.pl (check permissions)
-- Corrected a problem with a line in Profile.pl not being properly changed (hide user last login time)
-- Changed how the "hide_me" variable in user.vars file gets written (many thanks to Michael Prager for this suggestion!!!)
-- Now can be turned on and off in Admin Center
-- If turned off after being turned on, sets users .vars file's "hide_me" value to "" (blank)
-- If installed but turned off, board index will not show any part of hidden user mod until activated.
## 1.2 ##
-- Now able to include or exclude admins/gmods from Hidden User count (activate in Admin Center/Installed Mods).
-- Made it where when hidden user is online, to your regular members/moderators, the hidden user's profile shows "Last Online: Recently", but when hidden user logs off, profile reads "Last Online: {date/time}" as if they were never hidden (I might make that a switchable option as well if there are demands for it).
-- Admins and GMods see whether or not a hidden user is online/offline in profile (everyone else sees offline permanently).
-- Added column in "View/Delete Members" section of Admin Center to view who has enabled the hidden option (shows up as Yes or No).
-- Made it where if the hidden user mod is deactivated for any reason, the "hide_me" variable in the user.vars file does not disappear (thereby making the user have to re-check the option).
## 1.3 ##
-- Did minor coding fixes in BoardIndex.pl to remedy "gapping" problem between Hidden Users and Guests.
-- Finally fixed the Most Hidden Users counter problem.
## 1.4 ##
-- Adjusted code to work with Yabb 2.0 Final
-- Since no more bugs were reported or features were requested from the previous fix, this mod is now finalized.
## 1.5 ##
-- Adjusted code to work with Yabb 2.1
-- Added the option of allowing only Admins and GMods to see hidden users (i.e., guests do not see hidden user data).
## 1.6 ##
-- Added the option to only allow Admins and GMods to be hidden users while the rest of the regular members will not be able to hide.
-- Added option to clear users' "hide_me" value.
## 1.7 ##
-- Fixed a glitch with the hidden user counter where the GMods/Admins were still being counted even though the option to not count them was selected.

**Note:  If you have a translation made for this mod for another language, please email it to me so I can add it to the package.  Thanks, and enjoy!

</mod info>

<author>
Brian Longo
</author>

<homepage>
http://www.eyeontoccoa.com/mods/
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$hidden_user = "hidden_user|Hidden User Mod|Hidden User Mod|";
push (@boardmod_mods, "$hidden_user");
</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
&banning;     # Check for banned people
&WriteLog;    # Write to the log
&LoadIMs;     # Load IM's

</search for>

<add before>
## start hidden user mod ##
if (-e("$vardir/hidden_user.txt"))  {
    require "$vardir/hidden_user.txt";
}
## end hidden user mod ##
</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'helpediting',"EditHelpCentre.pl&HelpEdit",
'helpediting2',"EditHelpCentre.pl&HelpEdit2",
'helpsettings2',"EditHelpCentre.pl&HelpSet2",
'helporder',"EditHelpCentre.pl&SetOrderFile",
</search for>

<add after>
'hidden_user',"hidden_user.pl&hidden_user_set",  #hidden user mod
'hidden_user2',"hidden_user.pl&hidden_user_set_2",  #hiddenuser mod
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$hidden_user_mod = "Hidden User Mod|Brian Longo|Allows a member to become hidden from other users except Administrators and Global Moderators.|1.7|1/19/2006";
	push (@installed_mods, "$hidden_user_mod");
</add before>

<edit file>
Admin/ViewMembers.pl
</edit file>

<search for>
LoadLanguage("Main");
</search for>

<add after>
## start hidden user mod - load hidden_user.lng file ##
LoadLanguage("hidden_user");
## end hidden user mod ##
</add after>

<search for>
<form name="adv_memberview" action="$adminurl?action=deletemultimembers;$sortmode$sortorder" method="POST" style="display: inline" onSubmit="return submitproc()">
<input type="hidden" name="button" value="0" />
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
<tr>
	<td class="catbg" width="19%" align="center"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="19%" align="center"><b>$ml_txt{'87'}</b></td>
	<td class="catbg" width="19%" align="center" colspan="2"><b>$ml_txt{'21'}</b></td>
	<td class="catbg" width="19%" align="center"><b>$ml_txt{'234'}</b></td>
	<td class="catbg" width="19%" align="center" colspan="3"><b>$amv_txt{'4'}</b><br /><span class="small" style="float: left; text-align: center; width: 34%;">$amv_txt{'5'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'6'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'7'}</span></td>
	<td class="catbg" width="5%" align="center"><b>$admintxt{'38'}</b></td>
</tr>
~;

if ($LetterLinks ne "") {
	$TableHeader .= qq~<tr>
		<td class="catbg" colspan="9"><b>$LetterLinks</b></td>
	</tr>
	~;
}
</search for>

<replace>
<!-- ## start hidden user mod - add "hidden" column to table of members" ## -->
<form name="adv_memberview" action="$adminurl?action=deletemultimembers;$sortmode$sortorder" method="POST" style="display: inline" onSubmit="return submitproc()">
<input type="hidden" name="button" value="0" />
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
<tr>
	<td class="catbg" width="24%" align="center"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="12%" align="center"><b>$ml_txt{'87'}</b></td>
	<td class="catbg" width="17%" align="center" colspan="2"><b>$ml_txt{'21'}</b></td>
	<td class="catbg" width="17%" align="center"><b>$ml_txt{'234'}</b></td>
	<td class="catbg" width="17%" align="center" colspan="3"><b>$amv_txt{'4'}</b><br /><span class="small" style="float: left; text-align: center; width: 34%;">$amv_txt{'5'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'6'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'7'}</span></td>
	<td class="catbg" width="5%" align="center"><b>$admintxt{'38'}</b></td>
	<td class="catbg" width="10%" align="center"><b>$hidden_txt{'10'}</b></td>
</tr>
~;

if($LetterLinks ne "") {
	$TableHeader .= qq~<tr>
		<td class="catbg" colspan="10"><b>$LetterLinks</b></td>
	</tr>
	~;
}
## end hidden user mod ##
</replace>

<search for>
		$yymain .= qq~
		<td class="windowbg" width="19%">$memberinfo</td>
		<td class="windowbg2" width="5%" align="center">${$uid.$user}{'postcount'}</td>
		<td class="windowbg" width="14%">$Bar</td>
		<td class="windowbg" width="19%" >$dr_regdate &nbsp;</td>
		<td class="windowbg2" width="7%" align="center">$userlastonline</td>
		<td class="windowbg2" width="6%" align="center">$userlastpost</td>
		<td class="windowbg2" width="6%" align="center">$userlastim</td>
		<td class="windowbg" width="5%" align="center">$addel</td>
	</tr>~;
</search for>

<replace>
## start hidden user mod - add hidden user Yes/No data to table ##
		$yymain .= qq~
		<td class="windowbg" width="24%">$memberinfo</td>
		<td class="windowbg2" width="5%" align="center">${$uid.$user}{'postcount'}</td>
		<td class="windowbg" width="12%">$Bar</td>
		<td class="windowbg" width="10%" align="center">${$uid.$user}{'regdate'}&nbsp;</td>
		<td class="windowbg2" width="6%" align="center">$userlastonline</td>
		<td class="windowbg2" width="6%" align="center">$userlastpost</td>
		<td class="windowbg2" width="6%" align="center">$userlastim</td>
		<td class="windowbg" width="5%" align="center">$addel</td>
		<td class="windowbg2" width="8%" align="center">$hidden</td>
	</tr>~;
## end hidden user mod ##
</replace>

<search for>
		$yymain .= qq~
	<tr>
		<td class="windowbg" width="19%">$link{$user}</td>
		~;

		if ($user eq "admin") {
			$addel = qq~&nbsp;~;
		} else {
			$addel = qq~<input type="checkbox" name="member$numshown" value="$user" class="windowbg" style="border: 0; vertical-align: middle;" />~;
			$actualnum++;
		}

		my $userlastonline = ${$uid.$user}{'lastonline'};
		my $userlastpost   = ${$uid.$user}{'lastpost'};
		my $userlastim     = ${$uid.$user}{'lastim'};

</search for>

<add after>
## start hidden user mod - translate "on" to "Yes", blank to "No" ##
		if(${$uid.$user}{'hide_me'} eq "on"){$hidden = qq~<span style="color: red; font-weight: bold;">$hidden_txt{'11'}</span>~;}
		else{$hidden = $hidden_txt{'12'};}
## end hidden user mod ##

</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	$guests    = 0;
	$numusers  = 0;
</search for>

<replace>
## start hidden user mod part 1 - initialize hidden user counter ##
    $guests   = 0;
    $numusers = 0;
    if($allow_hidden eq 1){ 
       $numhidden = 0;
       $num_hidden_admin = 0;
       $hidden = qq~<span class="small">~;
    }
## end hidden user mod part 1 ##
</replace>

<search for>
				$numusers++;
				$users .= qq~$link{$name}~;
				if (($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
					$users .= qq~<i> ($last_ip)</i>~;
				}
				$users .= qq~, ~;
</search for>

<replace>
## start hidden user mod part 2 - count hidden users online and/or make them visible to admin/gmod ##
				if($allow_hidden eq 1 && ${$uid.$name}{'hide_me'} eq "on"){
				   if($count_admin_gmod ne 1){
				      if(${$uid.$name}{'position'} ne "Administrator" && ${$uid.$name}{'position'} ne "Global Moderator"){
					     $numhidden++;
				      }
					  else{$num_hidden_admin++;}
				   }
				   else{$numhidden++;}
				   if(($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
				      $hidden .= qq~<i>$link{$name} ($last_ip)</i>~;
					  $hidden .= qq~, ~;
				   }
				}
				else {
				$numusers++;
				$users .= qq~$link{$name}~;
				if(($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
					$users .= qq~<i> ($last_ip)</i>~;
				}
				$users .= qq~, ~;
				}
## end hidden user mod part 2 ##
</replace>

<search for>
	$users =~ s~, \Z~~;
	$users .= qq~</span>~;
	if ($numusers) { $users .= qq~<br />~; }
	$guestlist =~ s~, \Z~~;
	$guestlist .= qq~</span>~;
</search for>

<add after>
## start hidden user mod part 3 - assign html ##
	if($allow_hidden eq 1 && ($iamadmin || $iamgmod) && (($num_hidden_admin || $numhidden) ne 0)) {
	   $hidden =~ s~, \Z~~;
	   $hidden .= qq~</span>~;
	   $hidden .= qq~<br />~;
	}
    else{$hidden = qq~<!-- no hidden users -->~;}
## end hidden user mod part 3 ##
</add after>

<search for>
	$guestson = qq~<span class="small">$boardindex_txt{'141'}: <b>$guests</b></span>~;
	$userson  = qq~<span class="small">$boardindex_txt{'142'}: <b>$numusers</b></span>~;

	$totalusers = $numusers + $guests;
</search for>

<replace>
	$guestson = qq~<span class="small">$boardindex_txt{'141'}: <b>$guests</b></span>~;
	$userson = qq~<span class="small">$boardindex_txt{'142'}: <b>$numusers</b></span>~;
## start hidden user mod part 4 - show count of hidden users in board index ##
    if($only_admin_gmod_view || $allow_hidden_admin_gmod eq 1){
	   if($allow_hidden eq 1 && ($iamadmin || $iamgmod)) {$hiddenon = qq~<span class="small">$hidden_txt{'3'}: <b>$numhidden</b><br /></span>~;}
	   else {$hiddenon = qq~<!-- no hidden users -->~;}
	}
	elsif($allow_hidden eq 1 &&!$iamguest) {$hiddenon = qq~<span class="small">$hidden_txt{'3'}: <b>$numhidden</b><br /></span>~;}
	else {$hiddenon = qq~<!-- no hidden users -->~;}
	
	$totalusers = $numusers + $guests + $numhidden;
## end hidden user mod part 4 ##
</replace>

<search for>
	$boardindex_template =~ s/<yabb ims>/$ims/g;
	$boardindex_template =~ s/<yabb guests>/$guestson/g;
	$boardindex_template =~ s/<yabb users>/$userson/g;
</search for>

<add after>
## start hidden user mod part 5 - add hidden user names and counts to board index ##
    $boardindex_template =~ s/<yabb hidden>/$hiddenon/g;
	$boardindex_template =~ s/<yabb onlinehidden>/$hidden/g;
## end hidden user mod part 5 ##
</add after>

<search for>
LoadLanguage("BoardIndex");
</search for>

<add after>
## start hidden user mod part 6 - load hidden_user.lng file ##
LoadLanguage("hidden_user");
## end hidden user mod part 6 ##
</add after>

<search for>
	if (!-e ("$vardir/mostlog.txt")) {
		fopen(MOSTUSERS, ">$vardir/mostlog.txt");
		print MOSTUSERS "$numusers|$date\n";
		print MOSTUSERS "$guests|$date\n";
		print MOSTUSERS "$totalusers|$date\n";
</search for>

<add after>
## start hidden user mod part 7 - most hidden users ##
		if($allow_hidden eq 1) {
		   print MOSTUSERS "$numhidden|$date\n";
		}
## end hidden user mod part 7 ##
</add after>

<search for>
	chomp $datememb;
	chomp $dateguest;
	chomp $dateusers;

	if ($numusers >= $mostmemb || $guests >= $mostguest || $totalusers >= $mostusers) {
</search for>

<replace>
## start hidden user mod part 8.1 - add most hidden users to mostlog.txt ##
	if($allow_hidden eq 1) {($mosthidden, $datehidden) = split(/\|/,$mostentries[3]);}
	chomp $datememb;
	chomp $dateguest;
	chomp $dateusers; 
	if($allow_hidden eq 1) {chomp $datehidden;}
	if($numusers >= $mostmemb || $guests >= $mostguest || $totalusers >= $mostusers || $numhidden >= $mosthidden) {
## end hidden user mod part 8.1 ##
</replace>

<search for>
		if ($guests >= $mostguest)     { $mostguest = $guests;     $dateguest = $date; }
</search for>

<add after>
## start hidden user mod mod part 8.2 - add most hidden users to mostlog.txt ##
		if($allow_hidden eq 1) {
		if($numhidden >= $mosthidden) {$mosthidden = $numhidden; $datehidden = $date;}
		}
## end hidden user mod part 8.2 ##
</add after>

<search for>
		print MOSTUSERS "$mostusers|$dateusers\n";
</search for>

<add after>
## start hidden user mod mod part 8.3 - add most hidden users to mostlog.txt ##
		if($allow_hidden eq 1) { print MOSTUSERS "$mosthidden|$datehidden\n"; }
## end hidden user mod part 8.3 ##
</add after>

<search for>
	$themostuserdate  = &timeformat($dateusers);
</search for>

<add after>
## start hidden user mod part 9 - ready date to be displayed in board index ##
    if($only_admin_gmod_view || $allow_hidden_admin_gmod eq 1){
	   if($allow_hidden eq 1 && ($iamadmin || $iamgmod)) {
	      $mosthidedate = &timeformat($datehidden);
	      $themosthiddendate = qq~$maintxt{'30'} $mosthidedate<br />~;
	   }
	   else {$hiddenon = qq~<!-- no hidden users -->~;}
	}
    elsif ($allow_hidden eq 1 && !$iamguest) {
	   $mosthidedate = &timeformat($datehidden);
	   $themosthiddendate = qq~$maintxt{'30'} $mosthidedate<br />~;}
	else {$themosthiddendate = qq~<!-- no hidden users -->~;}
## end hidden user mod part 9 ##
</add after>

<search for>
	$themostguest = qq~$mostguest~;
</search for>

<add after>
## start hidden user mod part 10 - ready users to be displayed in board index ##
    if($only_admin_gmod_view || $allow_hidden_admin_gmod eq 1){
	   if($allow_hidden eq 1 && ($iamadmin || $iamgmod)) {$themosthidden = qq~$hidden_txt{'4'} <b>$mosthidden</b> ~;}
	   else {$hiddenon = qq~<!-- no hidden users -->~;}
	}
	elsif($allow_hidden eq 1 && !$iamguest) {$themosthidden = qq~$hidden_txt{'4'} <b>$mosthidden</b> ~;}
	else {$themosthidden = qq~<!-- no hidden users -->~;}
## end hidden user mod part 10 ##
</add after>

<search for>
	$boardindex_template =~ s/<yabb mostmembers>/$themostmemb/g;
	$boardindex_template =~ s/<yabb mostguests>/$themostguest/g;
	$boardindex_template =~ s/<yabb mostusers>/$themostuser/g;
</search for>

<add after>
## start hidden user mod part 11 - add most hidden user information to board index ##
	$boardindex_template =~ s/<yabb mosthidden>/$themosthidden/g;
	$boardindex_template =~ s/<yabb mosthiddendate>/$themosthiddendate/g;
## end hidden user mod part 11 ##
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$yymain .= qq~<tr class="windowbg">
          <td width="320" align="left"><b>$profile_txt{'228'}: </b></td>
          <td align="left"><input type="text" name="usertext" size="50" value="${$uid.$user}{'usertext'}" maxlength="50" /></td>
        </tr><tr class="windowbg">
</search for>

<replace>
## start hidden user mod - create checkbox for hidden user##
	$yymain .= qq~<tr class="windowbg">
          <td width="320" align="left"><b>$profile_txt{'228'}: </b></td>
          <td align="left"><input type="text" name="usertext" size="50" value="${$uid.$user}{'usertext'}" maxlength="50" /></td>
        </tr>~;
		if($allow_hidden eq 1) {
		   if((!$iamadmin || !$iamgmod) && $allow_hidden_admin_gmod ne 1){
		      if(${$uid.$user}{'hide_me'} eq "on") { $hiddencheck = 'checked';}
	          $yymain .= qq~	
		         <tr class="windowbg">
                    <td width="320" align="left"><b>$hidden_txt{'1'}</b></td>
                    <td align="left"><input type="checkbox" name="hiddenuser" $hiddencheck /></td>~;
		   }
		   elsif(($iamadmin || $iamgmod) && $allow_hidden_admin_gmod eq 1){
		      if(${$uid.$user}{'hide_me'} eq "on") { $hiddencheck = 'checked';}
	          $yymain .= qq~	
		         <tr class="windowbg">
                    <td width="320" align="left"><b>$hidden_txt{'1'}</b></td>
                    <td align="left"><input type="checkbox" name="hiddenuser" $hiddencheck /></td>~;
		   }
		}
	$yymain .= qq~
	</tr><tr class="windowbg">
<!-- ## end hidden user mod ## -->
</replace>

<search for>
		# Time to print the changes to the username.vars file
		${$uid.$user}{'usertext'}      = "$member{'usertext'}";
		${$uid.$user}{'userpic'}       = "$member{'userpic'}";
</search for>

<add after>
## start hidden user mod - add checkbox value to user.vars file ## 
        if($allow_hidden eq 1) {${$uid.$user}{'hide_me'} = "$FORM{'hiddenuser'}";}
		elsif ($allow_hidden ne 1 && ${$uid.$user}{'hide_me'} eq "on"){${$uid.$user}{'hide_me'} = "on";}
		else {${$uid.$user}{'hide_me'} = "";}
## end hidden user mod ##
</add after>

<search for>
	$online = qq~<img src="$imagesdir/off_led.png" alt="${$uid.$user}{'realname'} $profile_txt{'113'} $profile_txt{'687'}" />~;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if ($name) {
			&LoadUser($name);
			if (lc $name eq lc $INFO{'username'}) {
				$online = qq~<img src="$imagesdir/on_led.png" alt="${$uid.$user}{'realname'} $profile_txt{'113'} $profile_txt{'686'}" />~;
			}
		}
	}
</search for>

<replace>
	$online = qq~<img src="$imagesdir/off_led.png" alt="${$uid.$user}{'realname'} $profile_txt{'113'} $profile_txt{'687'}" />~;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
## start hidden user mod - check for hidden user ##
   		if($allow_hidden eq 1) {
		if(${$uid.$user}{'hide_me'} ne "on" || $iamadmin || $iamgmod) {
		if($name) {
			&LoadUser($name);
			if(lc $name eq lc $INFO{'username'}) {
				$online = qq~<img src="$imagesdir/on_led.png" alt="${$uid.$user}{'realname'} $profile_txt{'113'} $profile_txt{'686'}" />~;

			}
		}
		}
		}
## end hidden user mod ##
	}
</replace>

<search for>
LoadLanguage("Profile");
</search for>

<add after>
## start hidden user mod - load hidden_user.lng file ##
LoadLanguage("hidden_user");
## end hidden user mod ##
</add after>

<search for>
	<tr>
		<td class="windowbg2" align="left">
			<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
			<b>$profile_txt{'144'}: </b>
			</div>
			<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
			<a href="$scripturl?action=imsend;to=$useraccount{$INFO{'username'}}">$profile_txt{'688'} ${$uid.$user}{'realname'}</a>
			</div>
			$row_email
			$row_website
			$row_aim
			$row_msn
			$row_yim
			$row_gtalk
			$row_icq
		</td>
	</tr>
  ~;

	$userlastlogin = &timeformat(${$uid.$user}{'lastonline'});
	$userlastpost  = &timeformat(${$uid.$user}{'lastpost'});
	$userlastim    = &timeformat(${$uid.$user}{'lastim'});
</search for>

<replace>
	<tr>
		<td class="windowbg2" align="left">
			<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
			<b>$profile_txt{'144'}: </b>
			</div>
			<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
			<a href="$scripturl?action=imsend;to=$useraccount{$INFO{'username'}}">$profile_txt{'688'} ${$uid.$user}{'realname'}</a>
			</div>
			$row_email
			$row_website
			$row_aim
			$row_msn
			$row_yim
			$row_gtalk
			$row_icq
		</td>
	</tr>
  ~;

## start hidden user mod - check permissions to see last online date of hidden user while they're online ##
    if($allow_hidden eq 1) {
       if($iamadmin || $iamgmod || ${$uid.$user}{'hide_me'} ne "on") { $userlastlogin = &timeformat(${$uid.$user}{'lastonline'}); }
	   elsif (${$uid.$user}{'hide_me'} eq "on") { $userlastlogin = "$hidden_txt{'2'}"; }
	   else { $userlastlogin = &timeformat(${$uid.$user}{'lastonline'}); }
	}
	else { $userlastlogin = &timeformat(${$uid.$user}{'lastonline'}); }
## end hidden user mod ##
	$userlastpost  = &timeformat(${$uid.$user}{'lastpost'});
	$userlastim    = &timeformat(${$uid.$user}{'lastim'});
</replace>

<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(password realname email regdate webtitle weburl signature postcount position addgroups icq aim yim gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_notify im_popup im_imspop cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex);
</search for>

<add after>
	push(@tags,qw(hide_me)); # hidden user mod #
</add after>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
		<yabb users><br />
		<yabb onlineusers>
</search for>

<add after>
<!-- ## start hidden user mod - add most hidden users to board index ## --> 
		<yabb hidden><yabb onlinehidden>
<!-- ## end hidden user mod ## -->
</add after>

<search for>
		$boardindex_txt{'801'} <b><yabb mostmembers></b> $maintxt{'30'} <yabb mostmembersdate><br />
</search for>

<add after>
<!-- ## start hidden user mod - add most hidden user info to forum stats ## -->
		<yabb mosthidden><yabb mosthiddendate>
<!-- ## end hidden user mod ## -->
</add after>