<id>
Hidden Users patch for YaMMS
</id>

<version>

</version>

<mod info>
Install this patch only if you are running Carsten's YaMMS mod for YaBB 2.x.

This patch will keep your hidden users from showing up as online in the member list and on the member map.
</mod info>

<author>
Brian Longo
</author>

<homepage>

</homepage>

<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
		if ($view_online) {
			$onlinemem = qq~<img src="$imagesdir/red1.gif" border="0" alt="$maptxt{'47'}" />~;
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			foreach $curentry (@entries) {
				chomp $curentry;
				($onname, $onvalue, $onip) = split(/\|/, $curentry);
				if($onname eq $user) { $onlinemem = qq~<img src="$imagesdir/green1.gif" border="0" alt="$maptxt{'46'}" />~; }
			}
		}
</search for>

<replace>
		if ($view_online) {
			$onlinemem = qq~<img src="$imagesdir/red1.gif" border="0" alt="$maptxt{'47'}" />~;
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			foreach $curentry (@entries) {
				chomp $curentry;
				($onname, $onvalue, $onip) = split(/\|/, $curentry);
				if($onname eq $user && ${$uid.$onname}{'hide_me'} ne "on") { $onlinemem = qq~<img src="$imagesdir/green1.gif" border="0" alt="$maptxt{'46'}" />~; }
			}
		}
</replace>

<edit file>
Sources/MemberMap.pl
</edit file>

<search for>
			if(${$uid.$membname}{'gender'} eq "Male") {
				$pin = "bpin";
				if($memb_on) { $pin = "bpin_on"; }
			}
			elsif(${$uid.$membname}{'gender'} eq "Female") {
				$pin = "rpin";
				if($memb_on) { $pin = "rpin_on"; }
			}
			else {
				$pin = "gpin";
				if($memb_on) { $pin = "gpin_on"; }
			}
</search for>

<replace>
			if(${$uid.$membname}{'gender'} eq "Male") {
				$pin = "bpin";
				if($memb_on && ${$uid.$membname}{'hide_me'} ne "on") { $pin = "bpin_on"; }
			}
			elsif(${$uid.$membname}{'gender'} eq "Female") {
				$pin = "rpin";
				if($memb_on && ${$uid.$membname}{'hide_me'} ne "on") { $pin = "rpin_on"; }
			}
			else {
				$pin = "gpin";
				if($memb_on && ${$uid.$membname}{'hide_me'} ne "on") { $pin = "gpin_on"; }
			}
</replace>